//
//  SFController.h
//  StuffItNameFix
//
//  Created by Chang-Beom Park on 2/19/10.
//  Copyright 2010 trip2me.pe.kr. All rights reserved.
//

#import <Cocoa/Cocoa.h>

enum convert_type {
	OS9toOSX = 0,
    OSXtoOS9
};

extern NSString *SFConverterType;

@interface SFController : NSObject {

    IBOutlet NSPopUpButton *convertType;
    IBOutlet NSButton *directoryInclude;
    IBOutlet NSButton *tryMacKoreanCheckBox;
    IBOutlet NSProgressIndicator *spinner;


    id converter;
    int terminateAfterConverting;
    enum convert_type converterType;
    BOOL includeSubDirectory;
    BOOL tryMacKorean;

}

- (IBAction)converterChanged:(id)sender;
- (IBAction)includeDirectoryChanged:(id)sender;
- (IBAction)tryMacKoreanChanged:(id)sender;

- (void)filesDropped:(NSNotification *)n;

- (void)prepare:(NSArray *)filenames;

- (void)OSXFilenameFixWithPasteboard:(NSPasteboard *)pboard userData:(NSString *)data error:(NSString **)error;
- (void)OS9FilenameFixWithPasteboard:(NSPasteboard *)pboard userData:(NSString *)data error:(NSString **)error;

@end
