//
//  SFView.m
//  StuffItNameFix
//
//  Created by Chang-Beom Park on 2/19/10.
//  Copyright 2010 trip2me.pe.kr. All rights reserved.
//

#import "SFView.h"


@implementation SFView


- (id)initWithFrame:(NSRect)frameRect
{
	if (self = [super initWithFrame:frameRect]) {
		[self registerForDraggedTypes:
         [NSArray arrayWithObjects:NSFilenamesPboardType, nil]];
		_dragSessionInProgress = NO;
	}
	return self;
}

- (void)drawRect:(NSRect)rect
{
    
	[super drawRect:rect];
	if (_dragSessionInProgress) {
		[[NSColor selectedTextBackgroundColor] set];
		NSFrameRectWithWidth([self bounds], 3.0);
	}
}

- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender
{
	unsigned mask, ret;
    
	mask = [sender draggingSourceOperationMask];
	ret = (NSDragOperationGeneric & mask);
    
	if (ret != NSDragOperationNone) {
		_dragSessionInProgress = YES;
        [self setNeedsDisplay:YES];
	}
    
    [dragHereTitle setTextColor:[NSColor redColor]];
	//return ret;
    return NSDragOperationCopy;
}

- (void)draggingExited:(id <NSDraggingInfo>)sender
{    
    _dragSessionInProgress = NO;
    [dragHereTitle setTextColor:[NSColor blackColor]];
    
    [self setNeedsDisplay:YES];
}

- (void)concludeDragOperation:(id <NSDraggingInfo>)sender
{
	_dragSessionInProgress = NO;
    [self setNeedsDisplay:YES];
}

- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender
{
    
	return YES;
}

- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender
{
	NSArray *filenames;
	NSNotificationCenter *nc;
	NSPasteboard *pb;
    
	nc = [NSNotificationCenter defaultCenter];
	pb = [sender draggingPasteboard];
	filenames = [pb propertyListForType:@"NSFilenamesPboardType"];
    
	[nc postNotificationName:SFFilesDroppedNotification
                      object:filenames];
    
	return YES;
}

@end

NSString *SFFilesDroppedNotification = @"SFFilesDropped";
